/*
 File: lint_ballssym.cpp
 Date and Time: Fri Jan 30 18:55:15 2015 
*/
#include "lint_balls.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_lint_balls;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_lint_balls::TH_lint_balls(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_lint_balls;
  NS_lint_balls::Clint_balls Clint_balls_;// parallel-parser's parse table
#define ssPARSE_TABLE Clint_balls_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_lint_balls::PROC_TH_lint_balls(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_lint_balls";
  static bool one_time(false);
  static NS_lint_balls::Clint_balls* NS_lint_balls_Clint_balls_(0);// parallel-parser's fsm table
  static Parser* NS_lint_balls_Clint_balls_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_lint_balls_Clint_balls_ = new NS_lint_balls::Clint_balls();// parallel-parser's fsm table
    NS_lint_balls_Clint_balls_parser = new Parser(*NS_lint_balls_Clint_balls_,Caller_pp);
  }
 proc_parser = NS_lint_balls_Clint_balls_parser;
#include "wproc_pp_core.h"
}
void 
Clint_balls::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rlint_balls_:{
       Rlint_balls* sym;
     if(re->rule_ == 0){
       sym = new Rlint_balls(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint_balls*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rfluffs_:{
       Rfluffs* sym;
     if(re->rule_ == 0){
       sym = new Rfluffs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluffs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rfluffs_:{
       Rfluffs* sym;
     if(re->rule_ == 0){
       sym = new Rfluffs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluffs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rfluff_:{
       Rfluff* sym;
     if(re->rule_ == 0){
       sym = new Rfluff(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluff*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rfluff_:{
       Rfluff* sym;
     if(re->rule_ == 0){
       sym = new Rfluff(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluff*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rfluff_:{
       Rfluff* sym;
     if(re->rule_ == 0){
       sym = new Rfluff(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluff*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     return;}
    case rhs4_Rfluff_:{
       Rfluff* sym;
     if(re->rule_ == 0){
       sym = new Rfluff(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfluff*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    default: return;
   }
}
